/******************************************************************************
 * Copyright (C) 2013 Nuvoton(SH) Technology Corp. All rights reserved.
 ******************************************************************************/
#include  "uart_nano.h"
#include  "timer_nano.h"
 

#define UART_TEST_LENGTH  8

uint32_t i ;
uint8_t SrcArray[UART_TEST_LENGTH];
uint8_t DestArray[UART_TEST_LENGTH];


void PDMA_IRQHandler()
{
	if((PDMA2->ISR&PDMA_ISR_TD)!=0)
	{
		PDMA2->ISR|=PDMA_ISR_TD;	  //崫жϱ־
		for(i=0;i<UART_TEST_LENGTH;i++)
		{
		   SrcArray[i]=DestArray[i]+1; //յݼ1Ϊ 
		}
		PDMA1->CSR |=PDMA_CSR_TRIG_EN;
	}
	if((PDMA2->ISR&PDMA_ISR_TO)!=0)
	{
		PDMA2->ISR|=PDMA_ISR_TO;	//峬ʱжϱ־
		i = (PDMA2->BCR - PDMA2->CBCR);
		PDMA2->CSR |= PDMA_CSR_SWRST;
		if(i>0)
		{
			for(i=0;i<UART_TEST_LENGTH;i++)
			{
			   SrcArray[i]=DestArray[i]+1;	 //յݼ1Ϊ 
			}
			PDMA1->CSR |=PDMA_CSR_TRIG_EN;
		}
	}
}


/////////////////////////////////////////////////////////////////////////////////////////
int32_t main(void)							   
{
	UNLOCKREG();	
	CLK->PWRCTL|=CLK_PWRCTL_HIRC_EN;	
	while((CLK->CLKSTATUS& CLK_CLKSTATUS_HIRC_STB) == 0);	
	CLK->CLKSEL0 =CLK->CLKSEL0&( ~CLK_CLKSEL0_HCLK_MASK)|CLK_CLKSEL0_HCLK_HIRC;	
	CLK->CLKSEL1 = CLK->CLKSEL1&(~CLK_CLKSEL1_UART_MASK)|CLK_CLKSEL1_UART_HIRC;
	LOCKREG();
	
	GPIOE->PMD    = GPIO_PMD_PMD6_OUTPUT ;
    /* ʼUART */
	GCR->PB_L_MFP = PB1_MFP_UART0_TX | PB0_MFP_UART0_RX ;
	CLK->APBCLK  |=  CLK_APBCLK_UART0_EN ;
	UART0->TLCTL   = 0x3003 ;                      //8bit, 1-stop, no parity  
	UART0->BAUD    = 12000000/115200 - 1 ;         //UATR_CLK has been selected 12M  	
	UART0->CTL	|= UART_CTL_DMA_RX_EN|UART_CTL_DMA_TX_EN;  
	 
	/* ʼPDMA1 for UART0 TX */
	CLK->AHBCLK  |=  CLK_AHBCLK_DMA_EN ;
	PDMAGCR->CSR |= PDMAGCR_CSR_CLK1;	 //ʹPDMA1ʱ
	PDMAGCR->PDSSR0 = (PDMAGCR->PDSSR0 & 0xFFFF00FF )  //PDMA2UART0 TX
                   | PDMA_CH1_UART0_TX ;   
	PDMA1->SAR = (uint32_t)SrcArray;   //PDMA1Դַ
	PDMA1->DAR = UART0_BASE;		   //PDMA1Ŀĵַ
	PDMA1->CSR |= PDMA_CSR_SWRST|PDMA_CSR_APB_TWS_8BIT|PDMA_CSR_MEM2IP|PDMA_CSR_DAD_FIX|PDMA_CSR_CEN; 
	PDMA1->BCR	= UART_TEST_LENGTH;		 //PDMAݳ

    /* ʼPDMA2 for UART0 RX */
	PDMAGCR->CSR |= PDMAGCR_CSR_CLK2;	//ʹPDMA2ʱ
	PDMAGCR->PDSSR0 = (PDMAGCR->PDSSR0 & 0xFF00FFFF ) //PDMA2UART0 RX
                   | PDMA_CH2_UART0_RX ;
	PDMA2->SAR = UART0_BASE;			  //PDMA2Դַ
	PDMA2->DAR = (uint32_t)DestArray;	  //PDMA2Ŀĵַ
	PDMA2->CSR |= PDMA_CSR_SWRST|PDMA_CSR_APB_TWS_8BIT|PDMA_CSR_IP2MEM|PDMA_CSR_SAD_FIX|PDMA_CSR_CEN; 
	PDMA2->BCR	= UART_TEST_LENGTH;   //PDMAݳ

	PDMA2->TCR =36000;		     //ʱʱ 3.6S,ʱԴ10K	
	PDMA2->CSR |= PDMA_CSR_TOEN; //ʹܳʱʱ
	PDMA2->ISR|=PDMA_ISR_TO;	 //峬ʱ־
	PDMA2->IER |= PDMA_IER_TO;	 //ʹܳʱж

	PDMA2->IER |= PDMA_IER_TD;	 //ʹܴж
//	NVIC_EnableIRQ(PDMA_IRQn);
	NVIC->ISER[0]  = 1 << PDMA_IRQn ;

	while(1)
	{
	    for(i=0;i<UART_TEST_LENGTH;i++)
		{
		   SrcArray[i]=0;				 //UARTݻ
		   DestArray[i]=0;				 //UARTݻ
		}

		UART0->CTL |= 0x00000200; 	      //ʹUART
		PDMA2->CSR |=PDMA_CSR_TRIG_EN|PDMA_CSR_CEN;	  //PWMA2UART
		GPIOE->DOUT |= 0x40 ;
		UNLOCKREG();
		CLK->PWRCTL |= (CLK_PWRCTL_PWRDOWN_EN );	   /* Set power down bit */
		SCB->SCR |= 0x04;						   /* Sleep Deep */
		LOCKREG();                        	
		__wfi();

		GPIOE->DOUT &= ~0x40 ;			  //ʱLED˸һ
//	    PDMA1->CSR |=PDMA_CSR_TRIG_EN;	  //PWMA1UART
		for (i=0; i<10000; i++);		  //ʱ
	}		
}
