#include  "uart_nano.h"

////UART0 Initial ///////////////////////////////////////////////////////////////////////
void UART0_Init(uint32_t Baud)                 
{  
  CLK->APBCLK  |=  CLK_APBCLK_UART0_EN ;
  UART0->FUN_SEL = 0  ;                          //UART mode  
  UART0->TLCTL   = 0x3003 ;                      //8bit, 1-stop, no parity RTS:14,CTS:14   
  UART0->BAUD    = 12000000/Baud - 1 ;           //UATR_CLK has been selected 22M  
//  UART0->IER     = UART_IER_RDA_IE ;             //enable receive IRQ 
  UART0->CTL |= 0x00000200; 
  UART0->CTL	|= UART_CTL_DMA_RX_EN|UART_CTL_DMA_TX_EN;
//  NVIC_SetPriority(UART0_IRQn, 2) ;  
//  NVIC->ISER[0]  = 1 << UART0_IRQn ;
}

//// To fill TX FIFO with character, print character ////////////////////////////////////
// input :  *pStr,  string pointer.
//           Cnt,   character Number of string.
// return:   pStr,  First address of remaind character. Used for next time printing.
//           0,     All character has been printed.
uint8_t* Tx0FillFiFo(uint8_t*pStr, uint32_t Cnt)
{  
  while(Cnt){       
    if(UART0->FSR & UART_FSR_TX_FULL_F) break ;              
	  UART0->THR = *pStr++ ;    
		--Cnt ;  
  }  
  if(Cnt)return pStr ;  
  else  return 0 ;
}

////convert a integer into a string for printing ////////////////////////////////////////
//input : Number, 32bit integer
//       *pStr,  Last address saving character. Decreased after saving a character   
//return: Sum of character converted.
uint32_t HexToStr(uint32_t Number, uint8_t*pStr)
{  
  uint32_t Cnt = 0 ;  
  const uint8_t Asc[11] = "0123456789" ;
  
  do{    
    *pStr-- = Asc[Number%10] ;    
    Number /= 10 ;    
    ++Cnt ;  
  }while(Number);  
  return Cnt ;
}

// Print integer. Printing OK if return 0. Else, not all character is printed ///////////
uint8_t* Tx0FillFiFoHex(uint32_t Data)
{  
  uint32_t  Num ;  
  uint8_t   str[11] ;
  
  Num = HexToStr(Data,&str[10]) ;                         
  return  Tx0FillFiFo(&str[10]+1-Num, Num) ;
}


